var events = require('events');

var util = require('util');
var http = require('http');

var xml2json = require('./xml2json');

var TheTVDB = module.exports = function(key) {
	this.host = 'www.thetvdb.com';
	this.port = 80;
	this.key = key
}
TheTVDB.prototype.search = function(show, callBack) {
	if (!show) {
		callBack('First parma needs to be the show name.')
	}
	var url = '/api/GetSeries.php?seriesname=' + escape(show);
	this.query(url, callBack)
}
TheTVDB.prototype.getShow = function(id, callBack) {
	if (!id) {
		callBack('First parma needs to be the show id.')
	}
	var url = '/api/' + this.key + '/series/' + id + '/all/en.xml';
	this.query(url, callBack)
}
TheTVDB.prototype.getEpisodes = function(id, callBack) {
	if (!id) {
		callBack('First parma needs to be the episode id.')
	}
	var url = '/api/' + this.key + '/episodes/' + id + '/en.xml';
	this.query(url, callBack)
}
TheTVDB.prototype.query = function(url, callBack) {
	console.log(url)
	http.get({
		host : this.host,
		port : this.port,
		path : url
	}).on('response', function(response) {
		var page = [];
		response.setEncoding('utf8');
		response.on('data', function(chunk) {
			page.push(chunk);
		});
		response.on('end', function() {
			//console.log(page.join(''))
			if (response.statusCode == 200) {
				callBack(null, xml2json.parser(page.join('')).data);
			} else {
				callBack('Errpr calling the server.')
			}
		});
	});
	return this;
}
